<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_TransferInfo StructType
 * @subpackage Structs
 */
class JP_TransferInfo extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Type
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_TransferType
     */
    public $Type;
    /**
     * The Images
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_ImageLong
     */
    public $Images;
    /**
     * The CancellationPolicies
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_CancellationPolicyRules
     */
    public $CancellationPolicies;
    /**
     * The AdditionalDescriptions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_InfoDescription
     */
    public $AdditionalDescriptions;
    /**
     * The AdditionalFeatures
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_AdditionalFeature
     */
    public $AdditionalFeatures;
    /**
     * The CategoryCode
     * @var string
     */
    public $CategoryCode;
    /**
     * Constructor method for JP_TransferInfo
     * @uses JP_TransferInfo::setName()
     * @uses JP_TransferInfo::setDescription()
     * @uses JP_TransferInfo::setType()
     * @uses JP_TransferInfo::setImages()
     * @uses JP_TransferInfo::setCancellationPolicies()
     * @uses JP_TransferInfo::setAdditionalDescriptions()
     * @uses JP_TransferInfo::setAdditionalFeatures()
     * @uses JP_TransferInfo::setCategoryCode()
     * @param string $name
     * @param string $description
     * @param \StructType\JP_TransferType $type
     * @param \ArrayType\ArrayOfJP_ImageLong $images
     * @param \ArrayType\ArrayOfJP_CancellationPolicyRules $cancellationPolicies
     * @param \ArrayType\ArrayOfJP_InfoDescription $additionalDescriptions
     * @param \ArrayType\ArrayOfJP_AdditionalFeature $additionalFeatures
     * @param string $categoryCode
     */
    public function __construct($name = null, $description = null, \StructType\JP_TransferType $type = null, \ArrayType\ArrayOfJP_ImageLong $images = null, \ArrayType\ArrayOfJP_CancellationPolicyRules $cancellationPolicies = null, \ArrayType\ArrayOfJP_InfoDescription $additionalDescriptions = null, \ArrayType\ArrayOfJP_AdditionalFeature $additionalFeatures = null, $categoryCode = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setType($type)
            ->setImages($images)
            ->setCancellationPolicies($cancellationPolicies)
            ->setAdditionalDescriptions($additionalDescriptions)
            ->setAdditionalFeatures($additionalFeatures)
            ->setCategoryCode($categoryCode);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_TransferInfo
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\JP_TransferInfo
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Type value
     * @return \StructType\JP_TransferType|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param \StructType\JP_TransferType $type
     * @return \StructType\JP_TransferInfo
     */
    public function setType(\StructType\JP_TransferType $type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Images value
     * @return \ArrayType\ArrayOfJP_ImageLong|null
     */
    public function getImages()
    {
        return $this->Images;
    }
    /**
     * Set Images value
     * @param \ArrayType\ArrayOfJP_ImageLong $images
     * @return \StructType\JP_TransferInfo
     */
    public function setImages(\ArrayType\ArrayOfJP_ImageLong $images = null)
    {
        $this->Images = $images;
        return $this;
    }
    /**
     * Get CancellationPolicies value
     * @return \ArrayType\ArrayOfJP_CancellationPolicyRules|null
     */
    public function getCancellationPolicies()
    {
        return $this->CancellationPolicies;
    }
    /**
     * Set CancellationPolicies value
     * @param \ArrayType\ArrayOfJP_CancellationPolicyRules $cancellationPolicies
     * @return \StructType\JP_TransferInfo
     */
    public function setCancellationPolicies(\ArrayType\ArrayOfJP_CancellationPolicyRules $cancellationPolicies = null)
    {
        $this->CancellationPolicies = $cancellationPolicies;
        return $this;
    }
    /**
     * Get AdditionalDescriptions value
     * @return \ArrayType\ArrayOfJP_InfoDescription|null
     */
    public function getAdditionalDescriptions()
    {
        return $this->AdditionalDescriptions;
    }
    /**
     * Set AdditionalDescriptions value
     * @param \ArrayType\ArrayOfJP_InfoDescription $additionalDescriptions
     * @return \StructType\JP_TransferInfo
     */
    public function setAdditionalDescriptions(\ArrayType\ArrayOfJP_InfoDescription $additionalDescriptions = null)
    {
        $this->AdditionalDescriptions = $additionalDescriptions;
        return $this;
    }
    /**
     * Get AdditionalFeatures value
     * @return \ArrayType\ArrayOfJP_AdditionalFeature|null
     */
    public function getAdditionalFeatures()
    {
        return $this->AdditionalFeatures;
    }
    /**
     * Set AdditionalFeatures value
     * @param \ArrayType\ArrayOfJP_AdditionalFeature $additionalFeatures
     * @return \StructType\JP_TransferInfo
     */
    public function setAdditionalFeatures(\ArrayType\ArrayOfJP_AdditionalFeature $additionalFeatures = null)
    {
        $this->AdditionalFeatures = $additionalFeatures;
        return $this;
    }
    /**
     * Get CategoryCode value
     * @return string|null
     */
    public function getCategoryCode()
    {
        return $this->CategoryCode;
    }
    /**
     * Set CategoryCode value
     * @param string $categoryCode
     * @return \StructType\JP_TransferInfo
     */
    public function setCategoryCode($categoryCode = null)
    {
        // validation for constraint: string
        if (!is_null($categoryCode) && !is_string($categoryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($categoryCode, true), gettype($categoryCode)), __LINE__);
        }
        $this->CategoryCode = $categoryCode;
        return $this;
    }
}
